#!/usr/bin/perl
# 2007 Nicholas Polys     npolys@vt.edu
# Free to use; No warranties
# Attribution appreciated


use strict;



use Data::Dumper;

my  @Temp = [];
my $name;
my @data =  [],[];
my $items= 0;

if (!@ARGV){ $name = "fishspace_v1.txt";
}else {      $name = $ARGV[0];

}


# get your file and build an array
open(INPUTF,$name) or die "can't open ".$name." .out data file!!!\n ";

while (<INPUTF>) {
    @Temp = split /\s+/ ;
	$data[$items][0] = $Temp[0];      # id
	$data[$items][1] = $Temp[1];     #x
	$data[$items][2] = $Temp[2];       #y
	$data[$items][3] = $Temp[3];       #z
	$data[$items][4] = $Temp[4];        # eco
	$data[$items][5] = $Temp[5];        # zoo

     $items++;
}


close(INPUTF);



# prep your vrml text

my $vrml1 = "";
my $vrml2 = "";
my $router1 = "";

my $iter;
$vrml1 .= "  Transform { scale 5 5 5 children [ ";
for ($iter = 0; $iter < $items; $iter++){

$vrml1 .= "DEF p".$iter." semanticObject1C {";
$vrml1 .= "	geoRange [100]	 	infoRange [100]  \n ";
$vrml1 .= "	position  ".$data[$iter][1]." ".$data[$iter][2]." ".$data[$iter][3]." \n";
$vrml1 .= "  geoLevel [ DEF t".$data[$iter][0]." Transform { children [ \n";


  ###################################### # an ECO plot : RIVA, APPL, BLRI, CEAP

   if ($data[$iter][4] =~ /RIVA/)  {

$vrml1 .= "    Shape	{appearance Appearance {material Material {diffuseColor 1 0 0} }  ";
#$vrml1 .= "  		geometry Box { size .1 .1 .1}   ";
$vrml1 .= "				geometry  DEF p".$data[$iter][0]." Sphere{ radius .08  } ";

$router1 .= "ROUTE sriva.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }
   elsif
   ($data[$iter][4] =~ /APPL/)  {
$vrml1 .= "                     Shape	{appearance Appearance {material Material {diffuseColor 0 0 1} }   ";
#$vrml1 .= "				geometry Cone{ bottomRadius .1 height .1   } ";
$vrml1 .= "				geometry  DEF p".$data[$iter][0]." Sphere{ radius .08  } ";

$router1 .= "ROUTE sappl.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }
   elsif

   ($data[$iter][4] =~ /BLRI/)  {
$vrml1 .= "                     Shape	{appearance Appearance {material Material {diffuseColor 0 1 0} }   ";
$vrml1 .= "				geometry  DEF p".$data[$iter][0]." Sphere{ radius .08  } ";

$router1 .= "ROUTE sblri.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }
   else
   #($data[$iter][4] =~ /CEAD/)
    {
   }


$vrml1 .= " }]} \n Group {}  ]\n";

$vrml1 .= "infoLevel [";
$vrml1 .= "panel { message \"".$data[$iter][0]."\" }   ";

$vrml1 .= " ] } \n";

   ########################################### #a zoo plot      : NEW, ATL, OHI, TEN

}
 $vrml1 .= "    ]}";
 $vrml1 .= $router1;

open (OUTP,">meshtesteco.wrl") or die "can't open write file!!!\n ";

print OUTP $vrml1;

close (OUTP);



$router1 = "";




$vrml2 .= "  Transform {  scale 5 5 5 children [ ";
for ($iter = 0; $iter < $items; $iter++){

$vrml2 .= "DEF p".$iter." semanticObject1C {";
$vrml2 .= "	geoRange [100]	 	infoRange [100]  \n ";
$vrml2 .= "	position  ".$data[$iter][1]." ".$data[$iter][2]." ".$data[$iter][3]." \n";
$vrml2 .= "  geoLevel [ DEF t".$data[$iter][0]." Transform { children [ \n";


  ###################################### # an ECO plot : RIVA, APPL, BLRI, CEAP

   if ($data[$iter][5] =~ /NEW/)  {

$vrml2 .= "    Shape	{appearance Appearance {material Material {diffuseColor 1 0 0} }  ";
#$vrml2 .= "  		geometry Box { size .1 .1 .1}   ";
$vrml2 .= "				geometry Sphere{ radius .08  } ";
$router1 .= "ROUTE snew.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }
   elsif
   ($data[$iter][5] =~ /ATL/)  {
$vrml2 .= "                     Shape	{appearance Appearance {material Material {diffuseColor 0 0 1} }   ";
#$vrml2 .= "				geometry Cone{ bottomRadius .1 height .1   } ";
$vrml2 .= "				geometry Sphere{ radius .08  } ";
$router1 .= "ROUTE satl.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";

   }
   elsif

   ($data[$iter][5] =~ /OHI/)  {
$vrml2 .= "                     Shape	{appearance Appearance {material Material {diffuseColor 0 1 0} }   ";
$vrml2 .= "				geometry Sphere{ radius .08  } ";
$router1 .= "ROUTE sohi.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }
   else
   #($data[$iter][4] =~ /TEN/)
    {
$vrml2 .= "                     Shape	{appearance Appearance {material Material {diffuseColor 0 0 0} }   ";
#$vrml2 .= "				geometry Cylinder{radius .1 height	.1 } ";
$vrml2 .= "				geometry Sphere{ radius .08  } ";
$router1 .= "ROUTE sten.valueChanged3 TO t".$data[$iter][0].".set_scale \n    ";
   }


$vrml2 .= " }]} \n Group {}  ]\n";

$vrml2 .= "infoLevel [";
$vrml2 .= "panel { message \"".$data[$iter][0]."\" }   ";

$vrml2 .= " ] } \n";

   ########################################### #a zoo plot      : NEW, ATL, OHI, TEN





}
 $vrml2 .= "    ]}";

 $vrml2.= $router1;

open (OUTP,">meshtestzoo.wrl") or die "can't open write file!!!\n ";

print OUTP $vrml2;

close (OUTP);


 # append it to   the vrml file
